<?php
/*
Plugin Name: BP-Advanced-User-Search-Lite
Plugin URI: http://elive.net/
Description: Advanced user Search for BuddyPress
Version: 2.0.3.1
Author: Elive Ltd
Author URI: http://elive.net
Idea Author: Sean Ryan
Idea Author URI: http://elive.net
*/

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) die;

define( 'BP_AUS_PLUGIN_VERSION', '2.0.3.1' );
define( 'BP_AUS_PLUGIN_PATH', plugin_dir_path(__FILE__) );
define( 'BP_AUS_MAX_RANGE_FIELDS', 5 );
define( 'BP_AUS_MAX_MULTI_FIELDS', 5 );
define( 'BP_AUS_MAX_OR_GROUPS', 5 );

include BP_AUS_PLUGIN_PATH . 'functions.php';

//functions to display tabs across Buddy Preess Advanced User Search
include BP_AUS_PLUGIN_PATH . 'bp_aus_screentabs_functions.php';
include BP_AUS_PLUGIN_PATH . 'bp_aus_screetabs_settings_functions.php';
include BP_AUS_PLUGIN_PATH . 'bp_aus_screentabs_fast.php';
include BP_AUS_PLUGIN_PATH . 'bp_aus_screentabs_advanced.php';
include BP_AUS_PLUGIN_PATH . 'bp_aus_screentabs_settings.php';

//functions to show html search results
include BP_AUS_PLUGIN_PATH . 'bp_aus_sql_functions.php';
include BP_AUS_PLUGIN_PATH . 'bp_aus_html_functions.php';

include BP_AUS_PLUGIN_PATH . 'bp_aus_updater.php';

add_action('admin_menu', 'bp_aus_lite_admin_menu');
register_activation_hook(__FILE__, 'bp_aus_lite_activate');
register_deactivation_hook(__FILE__, 'bp_aus_lite_dectivate');
add_action( 'admin_enqueue_scripts', 'bp_aus_lite_admin_load_js_and_css' );


define('DEBUG', false);
$wp_plugin_auto_update = new bp_aus_lite_updater('http://update.elive.net/bp_aus_lite/', 'stable', basename(dirname(__FILE__)));

if (DEBUG) {
    // Enable update check on every request. Normally you don't need
    // this! This is for testing only!
    set_site_transient('update_plugins', null);
    add_filter('plugins_api_result', array($wp_plugin_auto_update, 'print_api_result'), 10, 3);// Show which variables are being requested when query plugin API
}
add_action('init', 'bp_aus_lite_register_session');
add_filter('pre_set_site_transient_update_plugins', array($wp_plugin_auto_update, 'check_for_plugin_update')); // Take over the update check
add_filter('plugins_api', array($wp_plugin_auto_update, 'plugins_api_call'), 10, 3); // Take over the Plugin info screen

add_action('admin_footer', 'bp_aus_lite_users_search_button'); // Action to add button to the native Users Search to go to Advanced Users Search
add_action('plugins_loaded', 'bp_aus_lite_check_version');
?>
