<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) die;

function bp_aus_lite_html_tab_switcher(){
	$displayOptions = array('On Screen');
	if(isset($_GET['tab'])){
		if($_GET['tab'] == 'fast') bp_aus_lite_screentabs_fast_search($displayOptions);
		elseif($_GET['tab'] == 'advanced') bp_aus_lite_screentabs_advanced_search($displayOptions);
		elseif($_GET['tab'] == 'settings') bp_aus_lite_screentabs_settings_form();
		else bp_aus_lite_screentabs_fast_search($displayOptions);
	}
	elseif(isset($_SESSION['bp_advanced_user_search']['mode'])){
		if($_SESSION['bp_advanced_user_search']['mode'] == 'fast') bp_aus_lite_screentabs_fast_search($displayOptions);
		elseif($_SESSION['bp_advanced_user_search']['mode'] == 'advanced') bp_aus_lite_screentabs_advanced_search($displayOptions);
		else bp_aus_lite_screentabs_fast_search($displayOptions);
	}
	else bp_aus_lite_screentabs_fast_search($displayOptions);
}

function bp_aus_lite_html_paginations($maxResults , $currentFound , $type = 'bottom'){
	$totalPages = floor( $currentFound / $maxResults );
	$tst = $currentFound % $maxResults;
	if($tst > 0) $totalPages ++;

	if(isset($_GET['paged'])){
		if(is_numeric($_GET['paged']) and $_GET['paged'] > 1) $currentPage = $_GET['paged'];
		else $currentPage = 1;
	}
	else $currentPage = 1;

	$PageUrl = $_SERVER['PHP_SELF'];
	if(isset($_GET['page']) ? $PageUrl .= '?page='.$_GET['page'] : $PageUrl .= '?page=Reports' );
	$PageSearchUrl = $PageUrl . '&action=search%_%';
	/*$args = array(
		'base' => $PageSearchUrl,
		'format' => '&paged=%#%',
		'current' => $currentPage,
		'show_all' => true,
		'total' => $totalPages,
		'end_size' => $maxResults
	);*/
	$args = array(
		'base' => $PageSearchUrl,
		'format' => '&paged=%#%',
		'current' => $currentPage,
		'total' => $totalPages,
		'end_size' => 3
	);
	$sub = '<div class="alignleft actions"><span style="font-weight:bold;">'.$currentFound.'</span>&nbsp;Users Found.&nbsp;<a href="'.$PageUrl.'">'.translate('Back To Search Form','buddypress').'</a></div>';
	echo '
	<div class="tablenav '.$type.'">
		<div class="tablenav-pages">
			'.$sub.'
			<span class="displaying-num">Show '.$maxResults.' users per page</span>
			' . paginate_links($args) . '
		</div>
	</div>';
}

function bp_aus_lite_html_errormsg($txt = 'No results found for specified search criteria.'){
	echo '<div class="error">'.translate($txt,'buddypress').'</div>';
	bp_aus_lite_html_tab_switcher();
}

function bp_aus_lite_html_show( $SqlResults , $MaxUsersOnPage ){
	global $bp;
	global $wpdb;

	$SearchOptions = get_option('bp_aus_lite_settings');
	$txt = '';
	$counter = 0;
	$PageUrl = $_SERVER['PHP_SELF'];
	if(isset($_GET['page']) ? $PageUrl .= '?page='.$_GET['page'] : $PageUrl .= '?page=Reports' );
	if(isset($_GET['paged']) and is_numeric($_GET['paged'])){
		$PageUrl .= '&amp;paged='.$_GET['paged'];
		$counter = ($_GET['paged'] - 1) * $MaxUsersOnPage;
	}

	if(is_array($SqlResults)){
		if(count($SqlResults) > 0){
			$usedFields = bp_aus_lite_sql_bp_fields($SearchOptions['showed_fields']);
			$colspan = ( count($usedFields) + 1 );
			$txt .= '
			<table class="wp-list-table widefat pages">
				<thead>
					<tr>
						<th scope="col">#</th>';

			if($SearchOptions['display_user_mail']){
				$txt .= '<th scope="col">'.translate('E-mail','buddypress').'</th>';
				$colspan++;
			}

			foreach($usedFields as $used_field_id => $used_field_name){
				$txt .= '<th scope="col">'.translate($used_field_name,'buddypress').'</th>';
			}
			$txt .= '
					</tr>
				</thead>
				<tfoot>
					<tr>
						<td colspan="'.$colspan.'">Powered by Buddy Press Advanced User Search</td>
					</tr>
				</tfoot>
				<tbody id="the-list">';

			foreach($SqlResults as $userData){
				$counter++;
				$uid = $userData->user_id;
				$subClass = bp_aus_lite_screentabs_functions_get_subclass($counter);
				$txt .= '
				<tr class="author-self status-inherit'.$subClass.'">
					<td>'.$counter.'</td>';

				if($SearchOptions['display_user_mail']){
					$user_mail = strtolower(bp_core_get_user_email($userData->user_id));
					$txt .= '<td>';
					if($user_mail != '' ? $txt .= '<a href="mailto:'.$user_mail.'">'.$user_mail.'</a>' : $txt .= '-' );
					$txt .= '</td>';
				}

				foreach($usedFields as $used_field_id => $used_field_name){
					$fieldData = xprofile_get_field_data($used_field_id,$uid);
					if(is_array($fieldData) ) $fieldData = implode(', ',$fieldData);
					if(trim($fieldData) == '') $fieldData = '&nbsp;';
					$txt .= '<td>'.$fieldData.'</td>';
				}
				$txt .= '</tr>';
			}
			$txt .= '</tbody></table>';
			echo $txt;
		}
		else bp_aus_lite_html_errormsg();
	}
	else bp_aus_lite_html_errormsg('Internal Error Please Try again.');
}
?>
