<?php
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) die;

function bp_aus_lite_screentabs_functions_form_header($FormTitle, $FormData = array('id' => '', 'name' => ''), $HiddenInputs = array( /* name => value of hidden input */ ), $FormClass = 'bp-aus-form' , $showTabs = false , $currentTab = 'fast', $FormAction = '', $MultipartForm = false, $NounceName = 'bp_aus_lite_html_page' ){
	if($FormAction == '') $FormAction = str_replace( array('%7E','&'), array('~','&amp;') , $_SERVER['REQUEST_URI'] );
	$txt = '
		<div class="wrap">';
	if($showTabs){
		$PageUrl = $_SERVER['PHP_SELF'];
		if(isset($_GET['page']) ? $PageUrl .= '?page='.$_GET['page'] : $PageUrl .= '?page=Reports' );
		$tabs = array( 'fast' => 'Fast Search', 'advanced' => 'Advanced Search');
		if( current_user_can('manage_options') )  $tabs['settings'] = 'Back-End Search Settings';

		$txt .= '
		<!--<div class="icon32" id="icon-buddypress"><br></div>-->
		<h2 class="nav-tab-wrapper">';
		foreach($tabs as $tab => $name){
			if ($currentTab == $tab ? $class = ' nav-tab-active' : $class = '');
			$txt .= '<a class="nav-tab'.$class.'" href="'.$PageUrl.'&amp;tab='.$tab.'">'.$name.'</a>';
		}
		$txt .= '</h2>';
	}
	if($MultipartForm == true ? $multi = ' enctype="multipart/form-data"' : $multi = '' );

	$txt .= '<form id="'.$FormData['id'].'" class="'.$FormClass.'" name="'.$FormData['name'].'" action="'.$FormAction.'" method="post"'.$multi.'>';
	if($FormTitle != '' ) $txt .= '<h1>'.$FormTitle.'</h1>';
	$txt .= wp_nonce_field($NounceName,'_wpnonce',true,false);
	foreach( $HiddenInputs as  $InputName => $InputValue){
		$txt .= '<input type="hidden" name="'.$InputName.'" id="'.$InputName.'" value="'.$InputValue.'" />';
	}
	return $txt;
}


function bp_aus_lite_screentabs_functions_get_subclass($counter){
	$subClass = $counter % 2 == 0 ? ' alt' : '';
	return $subClass;
}
function bp_aus_lite_screentabs_functions_form_row( $FieldName, $FieldValue, $FieldType, $FieldRequired, $LabelName, $options , $counter = 0 , $extras = '', $canBeEmpty = 1, $rowIsHidden = 0, $RangeField = false ){
	$subClass = bp_aus_lite_screentabs_functions_get_subclass($counter);
	if($rowIsHidden == 1) $subClass .= ' bp-aus-notdisplay';
	if($RangeField) $subClass .= ' bp-aus-rangefields';

	if($RangeField){
		if(isset($_POST[$FieldName . '_range_opt'])){
			$FieldValue['type'] = esc_attr(stripslashes($_POST[$FieldName . '_range_opt']));
		}
		if(isset($_POST[$FieldName . '_range1'])){
			if(!is_array($_POST[$FieldName . '_range1'])) $FieldValue['range1'] = esc_attr(stripslashes($_POST[$FieldName . '_range1']));
			else $FieldValue['range1'] = esc_attr( $_POST[$FieldName . '_range1'] );
		}
		if(isset($_POST[$FieldName . '_range2'])){
			if(!is_array($_POST[$FieldName . '_range2'])) $FieldValue['range2'] = esc_attr(stripslashes($_POST[$FieldName . '_range2']));
			else $FieldValue['range2'] = esc_attr( $_POST[$FieldName . '_range2'] );
		}
	}
	else{
		if(isset($_POST[$FieldName])){
			if(!is_array($_POST[$FieldName])) $FieldValue = esc_attr(stripslashes($_POST[$FieldName]));
			else $FieldValue = esc_attr( $_POST[$FieldName] );
		}
	}

	$optionBox = '';

	if( $FieldRequired ){
		$fieldRequired = '&nbsp;<span class="req">*</span>';
		$FieldSubClass = ' class="required"';
	}
	else{
		$fieldRequired = '';
		$FieldSubClass = '';
	}

	if($RangeField){
		if(empty($FieldSubClass)) $FieldSubClass = ' class="bp-aus-range_inpt"';
		else  $FieldSubClass = substr($FieldSubClass, 0, -1) . ' bp-aus-range_inpt"';
	}


	switch($FieldType){
		case "textbox":
			if($RangeField){
				$optionBox .= '<br>';
				$optionBox .= '<input type="text" name="'.$FieldName.'_range1" id="'.$FieldName.'_range1" value="'.$FieldValue['range1'].'"'.$FieldSubClass.' />';
				$optionBox .= '<span id="'.$FieldName.'_range_separator">&nbsp;-&nbsp;</span>';
				$optionBox .= '<input type="text" name="'.$FieldName.'_range2" id="'.$FieldName.'_range2" value="'.$FieldValue['range2'].'"'.$FieldSubClass.' />';
			}
			else{
				$optionBox .= '<input type="text" name="'.$FieldName.'" id="'.$FieldName.'" value="'.$FieldValue.'"'.$FieldSubClass.' />';
			}
		break;
		case 'textarea':
			$optionBox .=  '<textarea rows="5" cols="40" name="'.$FieldName.'" id="'.$FieldName.'"'.$FieldSubClass.'>'.$FieldValue.'</textarea>';
		break;
		case 'textarealarge':
			$optionBox .=  '<textarea rows="20" cols="80" name="'.$FieldName.'" id="'.$FieldName.'"'.$FieldSubClass.'>'.$FieldValue.'</textarea>';
		break;
		case "selectbox":
			if($RangeField){
				$optionBox .= '<br>';

				$optionBox .= '<select name="'.$FieldName.'_range1" id="'.$FieldName.'_range1"'.$FieldSubClass.'>';
				if($canBeEmpty) $optionBox .= '<option value="">Choose One</option>';
				foreach ($options as $option){
					if(isset($option->name) ? $optVal = trim($option->name) : $optVal = $option );
					if($optVal == $FieldValue['range1'] ? $chk = " selected='selected'": $chk =  "");
					$optionBox .= '<option value="'.htmlentities($optVal).'"'.$chk.'>'.translate(htmlentities($optVal),'buddypress').'</option>';
				}
				$optionBox .= '</select>';

				$optionBox .= '<span id="'.$FieldName.'_range_separator">&nbsp;-&nbsp;</span>';

				$optionBox .= '<select name="'.$FieldName.'_range2" id="'.$FieldName.'_range2"'.$FieldSubClass.'>';
				if($canBeEmpty) $optionBox .= '<option value="">Choose One</option>';
				foreach ($options as $option){
					if(isset($option->name) ? $optVal = trim ($option->name) : $optVal = $option );
					if($optVal == $FieldValue['range2'] ? $chk = " selected='selected'": $chk =  "");
					$optionBox .= '<option value="'.htmlentities($optVal).'"'.$chk.'>'.translate(htmlentities($optVal),'buddypress').'</option>';
				}
				$optionBox .= '</select>';
			}
			else{
				$optionBox .= '<select name="'.$FieldName.'" id="'.$FieldName.'"'.$FieldSubClass.'>';
				if($canBeEmpty) $optionBox .= '<option value="">Choose One</option>';
				foreach ($options as $option){
					if(isset($option->name) ? $optVal = trim($option->name) : $optVal = $option );
					if($optVal == $FieldValue ? $chk = " selected='selected'": $chk =  "");
					$optionBox .= '<option value="'.htmlentities($optVal).'"'.$chk.'>'.translate(htmlentities($optVal),'buddypress').'</option>';
				}
				$optionBox .= '</select>';
			}
		break;
		case "idselectbox":
			if($RangeField){
				$optionBox .= '<br>';

				$optionBox .= '<select name="'.$FieldName.'_range1" id="'.$FieldName.'_range1"'.$FieldSubClass.'>';
				if($canBeEmpty) $optionBox .= '<option value="">Choose One</option>';
				foreach ($options as $key => $option){
					$optVal = $key;
					$optName = $option;
					if($optVal == $FieldValue['range1'] ? $chk = " selected='selected'": $chk = "");
					$optionBox .= '<option value="'.htmlentities($optVal).'"'.$chk.'>'.translate(htmlentities($optName),'buddypress').'</option>';
				}
				$optionBox .= '</select>';

				$optionBox .= '<span id="'.$FieldName.'_range_separator">&nbsp;-&nbsp;</span>';

				$optionBox .= '<select name="'.$FieldName.'_range2" id="'.$FieldName.'_range2"'.$FieldSubClass.'>';
				if($canBeEmpty) $optionBox .= '<option value="">Choose One</option>';
				foreach ($options as $key => $option){
					$optVal = $key;
					$optName = $option;
					if($optVal == $FieldValue['range2'] ? $chk = " selected='selected'": $chk = "");
					$optionBox .= '<option value="'.htmlentities($optVal).'"'.$chk.'>'.translate(htmlentities($optName),'buddypress').'</option>';
				}
				$optionBox .= '</select>';
			}
			else{
				$optionBox .= '<select name="'.$FieldName.'" id="'.$FieldName.'"'.$FieldSubClass.'>';
				if($canBeEmpty) $optionBox .= '<option value="">Choose One</option>';
				foreach ($options as $key => $option){
					$optVal = $key;
					$optName = $option;
					if($optVal == $FieldValue ? $chk = " selected='selected'": $chk = "");
					$optionBox .= '<option value="'.htmlentities($optVal).'"'.$chk.'>'.translate(htmlentities($optName),'buddypress').'</option>';
				}
				$optionBox .= '</select>';
			}
			break;
		case 'multiselectbox':
			$NoItems = count($options);
			$NoSelectedItems = 0;
			$optionBox = '<select name="'.$FieldName.'[]" id="'.$FieldName.'" multiple="multiple"'.$FieldSubClass.'>';
			foreach ($options as $option){
				if(isset($option->name) ? $optVal = trim ($option->name) : $optVal = $option );
				if( strpos($FieldValue, $optVal) === false ? $chk =  '' : $chk = ' selected="selected"' );
				if(isset($_POST[$FieldName]) and is_array($_POST[$FieldName])){
					if(in_array($optVal, $_POST[$FieldName] ) ? $chk = ' selected="selected"' : $chk =  '');
				}
				if($chk == ' selected="selected"') $NoSelectedItems++;
				$optionBox .= '<option value="'.htmlentities($optVal).'"'.$chk.'>'.translate(htmlentities($optVal),'buddypress').'</option>';
			}
			$optionBox .= '</select>';
			if($NoItems > 1){
				$optionBox .= '&nbsp;<a href="#" class="bpaus_select_all" data-mode="';
				if($NoSelectedItems == $NoItems) $optionBox .= '1">Deselect';
				else $optionBox .= '0">Select';
				$optionBox .= ' All</a>';
			}
		break;
		case 'radio':
			$optionBox .= '';
			$subCounter = 0;
			$NoItems = count($options);
			if($NoItems > 1){
				$optionBox .= '<div class="bp-aus-multiple-options">';
			}
			foreach ($options as $option){
				$subCounter++;
				$option->name = trim($option->name);
				if($option->name == $FieldValue ? $chk = ' checked="checked"' : $chk = '');
				$optionBox .= '
				<input type="radio" name="'.$FieldName.'" id="'.$FieldName.'-'.$subCounter.'" value="'.$option->name.'"'.$chk .$FieldSubClass.' />
				<label class="bpaus-inlabel" for="'.$FieldName.'-'.$subCounter.'">'.$option->name.'</label><br/>';
			}
			if($NoItems > 1){
				$optionBox .= '</div>';
			}
		break;
		case 'checkbox':
			$NoItems = count($options);
			$NoSelectedItems = 0;
			$subCounter = 0;
			if($NoItems > 1){
				$optionBox .= '<div class="bp-aus-multiple-options">';
			}
			foreach ($options as $option){
				$chk = '';
				$subCounter++;
				if(isset($option->name) ? $optVal = trim($option->name) : $optVal = $option );
				if(is_array($FieldValue) && in_array($optVal, $FieldValue)) $chk = ' checked="checked"';
				elseif(isset($_POST[$FieldName]) && is_array($_POST[$FieldName])){
					if(in_array($optVal, $_POST[$FieldName])) $chk = ' checked="checked"';
				} else{
					if($optVal == $FieldValue) $chk = ' checked="checked"';
					elseif(isset($_POST[$FieldName]) && $optVal == $_POST[$FieldName]) $chk = ' checked="checked"';
				}
				if($chk == ' checked="checked"') $NoSelectedItems++;
				$optionBox .= '
				<input type="checkbox" name="'.$FieldName.'[]" id="'.$FieldName.'-'.$subCounter.'" value="'.$optVal.'"'.$chk. $FieldSubClass.' />
				<label class="bpaus-inlabel" for="'.$FieldName.'-'.$subCounter.'">'. translate($optVal, 'buddypress'). '</label><br/>';
			}
			if($NoItems > 1){
				$optionBox .= '&nbsp;<a href="#" class="bpaus_select_all" data-mode="';
				if($NoSelectedItems == $NoItems) $optionBox .= '1">Deselect';
				else $optionBox .= '0">Select';
					$optionBox .= ' All</a>';
					$optionBox .= '</div>';
			}
		break;
		case 'datebox':
			if($FieldValue != ''){
				$strippedDate = explode('-',date('Y-m-d',strtotime($FieldValue)));
				$subSlct = '';
			}
			else{
				$strippedDate = array('','','');
				$subSlct = " selected='selected'";
			}
			$yearRangeStart = 1901;
			$yearRangeEnd = 2037;
			if($FieldSubClass != '' ? $DateFieldClass = ' class="bpaus-small required"' : $DateFieldClass = ' class="bpaus-small"' );
			$optionBox .= '<select name="date_day_'.$FieldName.'" id="date_day_'.$FieldName.'"'.$DateFieldClass.'>';
			$optionBox .= '<option value=""'.$subSlct.'>Day</option>';
			for($i = 1; $i <= 31; $i++){
				if($i < 10 ? $shwdI = '0'.$i : $shwdI = $i );
				if($i == $strippedDate[2] ? $chk = " selected='selected'": $chk =  "");
				$optionBox .= '<option value="'.$shwdI.'"'.$chk.'>'.$shwdI.'</option>';
			}
			$optionBox .= '</select>&nbsp;';
			$optionBox .= '<select name="date_month_'.$FieldName.'" id="date_month_'.$FieldName.'"'.$DateFieldClass.'>';
			$optionBox .= '<option value=""'.$subSlct.'>Month</option>';
			for($i = 1; $i <= 12; $i++){
				if($i < 10 ? $shwdI = '0'.$i : $shwdI = $i );
				if($i == (int)$strippedDate[1] ? $chk = " selected='selected'": $chk =  "");
				$showedMonth = '';
				$optionBox .= '<option value="'.$shwdI.'"'.$chk.'>'.translate(date('F', strtotime('1970-'.$shwdI.'-01')),'buddypress').'</option>';
			}
			$optionBox .= '</select>&nbsp;';
			$optionBox .= '<select name="date_year_'.$FieldName.'" id="date_year_'.$FieldName.'"'.$DateFieldClass.'>';
			$optionBox .= '<option value=""'.$subSlct.'>Year</option>';
			for($i = $yearRangeEnd; $i >= $yearRangeStart; $i--){
				if($i == $strippedDate[0] ? $chk = " selected='selected'": $chk =  "");
				$optionBox .= '<option value="'.$i.'"'.$chk.'>'.$i.'</option>';
			}
			$optionBox .= '</select>';
		break;
		case 'password':
			$optionBox = '<input type="password" name="'.$FieldName.'" id="'.$FieldName.'" value=""'.$FieldSubClass.' />';
		break;
		case 'empty':
			$optionBox = '&nbsp;';
		break;
		case "upload":
			$optionBox .= '<input type="file" name="'.$FieldName.'" id="'.$FieldName.'" value="'.$FieldValue.'"'.$FieldSubClass.' />';
		break;
		default:
			if($RangeField){
				$optionBox .= '<br>';
				$optionBox .= '<input type="text" name="'.$FieldName.'_range1" id="'.$FieldName.'_range1" value="'.$FieldValue['range1'].'"'.$FieldSubClass.' />';
				$optionBox .= '<span id="'.$FieldName.'_range_separator">&nbsp;-&nbsp;</span>';
				$optionBox .= '<input type="text" name="'.$FieldName.'_range2" id="'.$FieldName.'_range2" value="'.$FieldValue['range2'].'"'.$FieldSubClass.' />';
			}
			else{
				$optionBox .= '<input type="text" name="'.$FieldName.'" id="'.$FieldName.'" value="'.$FieldValue.'"'.$FieldSubClass.' />';
			}
		break;
	}

	if($RangeField){
		$label = '
		<div class="bpaus-range-label">
			<p>
				'.translate($LabelName,'buddypress').$fieldRequired.'&nbsp;
				<a href="#" class="bp-aus-range-reset">'.translate('Reset','buddypress').'</a>
			</p>
			<p>
				<label for="'.$FieldName.'_range_opt_single">'.translate('Single','buddypress').'</label>
				<input type="radio" name="'.$FieldName.'_range_opt" id="'.$FieldName.'_range_opt_single" value="single"'.($FieldValue['type'] == 'single' ? ' checked="checked"' : '').' class="bp-aus-range-radio" />
				<label for="'.$FieldName.'_range_opt_multiple">'.translate('Multiple','buddypress').'</label>
				<input type="radio" name="'.$FieldName.'_range_opt" id="'.$FieldName.'_range_opt_multiple" value="multiple"'.($FieldValue['type'] == 'multiple' ? ' checked="checked"' : '').' class="bp-aus-range-radio" />
			</p>
		</div>';
	}
	else{
		if(in_array($FieldType,array('radio','checkbox','datebox','empty'))){
			$label = '<div class="bpaus-label">'.translate($LabelName,'buddypress').$fieldRequired.'</div>';
		}
		else{
			$label = '<label for="'.$FieldName.'">'.translate($LabelName,'buddypress').$fieldRequired.'</label>';
		}
	}



	return '
	<div class="editfield'.$subClass.'">
	' .$label . $optionBox . $extras . '
	</div>';
}

function bp_aus_lite_screentabs_functions_upgrade_info(){
	$txt .= '
	<div id="side-container" class="postbox-container bp-aus-upgrade-info">
		<div class="postbox " id="ngg_meta_box">
			<div title="Click to toggle" class="handlediv"><br></div>
			<h3 class="hndle"><span>Do you like this Plugin?</span></h3>
			<div class="inside">
				If you need more functions within this plugin please visit our <a href="https://www.elive.net/wp-buddypress-advanced-user-search-plugin/">site</a> to purchase the Full version of this plugin for only &euro;40 per licence. Full version includes CSV Download option, ability to add new users from one screen, custom search form on Front End of your site, Import from CSV & ability to customise the CSS.
			</div>
		</div>
	</div>
	';
	return $txt;
}
?>
