<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) die;

function bp_aus_lite_screentabs_settings_form(){
	if ( current_user_can('manage_options') ){
		$alreadySet = get_option('bp_aus_lite_settings');
		//echo "<pre>"; var_dump($alreadySet);
		$Options = bp_aus_lite_settings_options();
		$ShowFields = bp_aus_lite_screentabs_settings_get_showed_fields($alreadySet['showed_fields']);
		$ShowFields2 = bp_aus_lite_screentabs_settings_get_showed_fields($alreadySet['showed_form_fields'], 'bp_aus_lite_settings_showed_form_fields');

		$ShowRangeFields = array();
		for($rangeCnt = 1; $rangeCnt <= BP_AUS_MAX_RANGE_FIELDS; $rangeCnt++){
			$ShowRangeFields[$rangeCnt] = bp_aus_lite_screentabs_settings_get_showed_fields(array($alreadySet['range'.$rangeCnt]), 'bp_aus_lite_settings_range_'.$rangeCnt, 0, 'None');
		}

		$ShowMultiFields = array();
		for($multiCnt = 1; $multiCnt <= BP_AUS_MAX_MULTI_FIELDS; $multiCnt++){
			$ShowMultiFields[$multiCnt] = bp_aus_lite_screentabs_settings_get_showed_fields(array($alreadySet['multi'.$multiCnt]), 'bp_aus_lite_settings_multi_'.$multiCnt, 0, 'None');
		}

		$ShowOrGroups = array();
		for($orCnt = 1; $orCnt <= BP_AUS_MAX_OR_GROUPS; $orCnt++){
			$ShowOrGroups[$orCnt] = bp_aus_lite_screentabs_settings_get_showed_fields((array)$alreadySet['or'.$orCnt], 'bp_aus_lite_settings_or_'.$orCnt, 1, 'None');
		}

		if( $alreadySet['display_user_mail'] == true ? $umailChkCheck = ' checked="checked"' : $umailChkCheck = '' );
		$umailChk = '<input type="checkbox" name="bp_aus_lite_settings_show_user_mail" id="bp_aus_lite_settings_show_user_mail" value="1"'.$umailChkCheck.' />';
		$txt = '';
		$txt .= bp_aus_lite_screentabs_functions_form_header(
			'',
			array('id' => 'bp_aus_lite_form', 'name' => 'bp_aus_lite_form'),
			array('action' => 'bp_aus_lite_setup'),
			'bp-aus-form',
			true,
			'settings'
		);
		$counter = 1;
		$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_settings_results', $alreadySet['max_results_on_page'], 'selectbox', true, 'Max Results On Search Page', $Options['max_results_on_page'] , $counter, '', false );
		$counter++;
		$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_settings_showed_fields', '', 'empty', true, 'Showed Fields On Results', '' , $counter, $ShowFields , false );
		$counter++;
		$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_settings_showed_form_fields', '', 'empty', true, 'Showed Fields On Search Form', '' , $counter, $ShowFields2 , false );
		$counter++;
		$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_settings_default_opt', $alreadySet['search_options'], 'selectbox', true, 'Search Options', $Options['search_behaviour'] , $counter, '', false );
		$counter++;
		$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_settings_search_type_checkbox', $alreadySet['search_type_checkbox'], 'selectbox', true, 'Checkbox Search Type', $Options['search_type_checkbox'] , $counter, '', false );
		$counter++;
		$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_settings_show_user_mail', '', 'empty', true, 'Display E-mails On Results', '' , $counter, $umailChk , false );

		for($rangeCnt = 1; $rangeCnt <= BP_AUS_MAX_RANGE_FIELDS; $rangeCnt++){
			$counter++;
			$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_settings_range_'.$rangeCnt, '', 'empty', false, 'Range Field '.$rangeCnt, '' , $counter, $ShowRangeFields[$rangeCnt] , false );
		}

		$txt .= '<div style="margin: 20px 0 10px 0; font-weight: bold;">Select up to ' . BP_AUS_MAX_MULTI_FIELDS . ' multi fields below. Multi fields will allow searching in the WP Admin area with multiple versions of the same field to be compared with an OR operator.</div>';
		for($multiCnt = 1; $multiCnt <= BP_AUS_MAX_MULTI_FIELDS; $multiCnt++){
			$counter++;
			$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_settings_multi_'.$multiCnt, '', 'empty', false, 'Multi Field '.$multiCnt, '' , $counter, $ShowMultiFields[$multiCnt] , false );
		}

		$txt .= '<div style="margin: 20px 0 10px 0; font-weight: bold;">Select up to ' . BP_AUS_MAX_OR_GROUPS . ' groups of OR fields below. Fields included in each group will be compared with an OR operator instead of an AND in the WP Admin area search.</div>';
		for($orCnt = 1; $orCnt <= BP_AUS_MAX_OR_GROUPS; $orCnt++){
			$counter++;
			$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_settings_or_'.$orCnt, '', 'empty', false, 'Or Group '.$orCnt, '' , $counter, $ShowOrGroups[$orCnt] , false );
		}
		$txt .= bp_aus_lite_screentabs_settings_get_buttons();
		$txt .= bp_aus_lite_screentabs_functions_upgrade_info();
		echo $txt;
	}
	else bp_aus_lite_html_errormsg('You have to be logged as a adminitrator to make changes in bp advanced user search ');
}

function bp_aus_lite_screentabs_settings_update(){
	if ( current_user_can('manage_options') ){
		$txt = '';
		$error = array();
		$fields = bp_aus_lite_sql_bp_fields();
		$Options = bp_aus_lite_settings_options();


		if(!empty($_POST['bp_aus_lite_settings_results']) and  !in_array($_POST['bp_aus_lite_settings_results'],$Options['max_results_on_page'])) $error[] = 'Invalid value provided in "Max Results On Search Page"';
		if(!empty($_POST['bp_aus_lite_settings_search_opt']) and !in_array($_POST['bp_aus_lite_settings_search_opt'],$Options['search_behaviour'])) $error[] = 'Invalid value provided in "Search Options"';
		if(!empty($_POST['bp_aus_lite_settings_search_type_checkbox']) and !in_array($_POST['bp_aus_lite_settings_search_type_checkbox'],$Options['search_type_checkbox'])) $error[] = 'Invalid value provided in "Search Checkbox"';
		///if(!empty($_POST['bp_aus_lite_settings_default_type']) and !in_array($_POST['bp_aus_lite_settings_default_opt'],$Options['search_behaviour'])) $error[] = 'Invalid value provided in "Default Search Type"';
		if(!empty($_POST['bp_aus_lite_settings_show_user_mail']) and !in_array($_POST['bp_aus_lite_settings_show_user_mail'],$Options['show_mail'])) $error[] = 'Invalid value provided in "Display Users E-mails On Results Page"';


		if(!empty($_POST['bp_aus_lite_settings_showed_fields']) and !is_array($_POST['bp_aus_lite_settings_showed_fields'])) $error[] = 'Please select at least one field from "Showed Fields On Results Page"';
		else{
			$totalFields = count($fields);
			$selectedFields = 0;
			$selectedValues = array();

			foreach($_POST['bp_aus_lite_settings_showed_fields'] as $value){
				if(is_numeric($value) and $value > 0){
					$selectedFields++;
					$selectedValues[] = $value;
				}
			}

			if($selectedFields == 0) $error[] = 'Please select at least one field from "Showed Fields On Results Page"';
			if($selectedFields == $totalFields) $selectedValues = 'all';
		}

		if(!empty($_POST['bp_aus_lite_settings_showed_form_fields']) and !is_array($_POST['bp_aus_lite_settings_showed_form_fields'])) $error[] = 'Please select at least one field from "Showed Fields On Search Form"';
		else{
			$totalFields = count($fields);
			$selectedFields2 = 0;
			$selectedValues2 = array();

			foreach($_POST['bp_aus_lite_settings_showed_form_fields'] as $value){
				if(is_numeric($value) and $value > 0){
					$selectedFields2++;
					$selectedValues2[] = $value;
				}
			}

			if($selectedFields2 == 0) $error[] = 'Please select at least one field from "Showed Fields On Search Form"';
			if($selectedFields2 == $totalFields) $selectedValues2 = 'all';
		}

		for($rangeCnt = 1; $rangeCnt <= BP_AUS_MAX_RANGE_FIELDS; $rangeCnt++){
			if(!empty($_POST['bp_aus_lite_settings_range_'.$rangeCnt])){
				if(!is_numeric($_POST['bp_aus_lite_settings_range_'.$rangeCnt])) $error[] = 'Invalid value in "Range Field '. $rangeCnt .'"';

				$rangeFields[] = $_POST['bp_aus_lite_settings_range_'.$rangeCnt];
			}
		}
		for($multiCnt = 1; $multiCnt <= BP_AUS_MAX_MULTI_FIELDS; $multiCnt++){
			if(!empty($_POST['bp_aus_lite_settings_multi_'.$multiCnt])){
				if(!is_numeric($_POST['bp_aus_lite_settings_multi_'.$multiCnt])) $error[] = 'Invalid value in "Multi Field '. $multiCnt .'"';
				elseif(array_search($_POST['bp_aus_lite_settings_multi_'.$multiCnt], $rangeFields) !== false) $error[] = 'A "Range Field" cannot be a "Multi Field" (' . $multiCnt . ')';
			}
		}
		for($orCnt = 1; $orCnt <= BP_AUS_MAX_OR_GROUPS; $orCnt++){
			if (!empty($_POST['bp_aus_lite_settings_or_'.$orCnt]) && is_array($_POST['bp_aus_lite_settings_or_'.$orCnt])){
				foreach ($_POST['bp_aus_lite_settings_or_'.$orCnt] as $value){
					if(!is_numeric($value)){
						$error[] = 'Invalid value in "Or Group '. $orCnt .'"';

						break;
					}
				}
			} elseif (!empty($_POST['bp_aus_lite_settings_or_'.$orCnt]) && !is_array($_POST['bp_aus_lite_settings_or_'.$orCnt])){
				$error[] = 'Invalid value in "Or Group '. $orCnt .'"';
			}
		}

		if(sizeof($error)){
			$txt .= '<div class="error">'.translate('Errors occurred during update settings process:','buddypress').'<br />';
			foreach($error as $errDescr){
				$txt .= translate($errDescr).'<br />';
			}
			$txt .= '</div>';
		}
		else{
			if($_POST['bp_aus_lite_settings_show_user_mail'] == '1' ? $selectedMail = true : $selectedMail = false );
			$optValue = array(
				'max_results_on_page' => $_POST['bp_aus_lite_settings_results'],
				'showed_fields' => $selectedValues,
				'showed_form_fields' => $selectedValues2,
				'search_options' => $_POST['bp_aus_lite_settings_default_opt'],
				'search_type_checkbox' => $_POST['bp_aus_lite_settings_search_type_checkbox'],
				'display_user_mail' => $selectedMail
			);
			for($rangeCnt = 1; $rangeCnt <= BP_AUS_MAX_RANGE_FIELDS; $rangeCnt++){
				$optValue['range'.$rangeCnt] = filter_var($_POST['bp_aus_lite_settings_range_'.$rangeCnt],FILTER_SANITIZE_NUMBER_INT);
			}
			for($multiCnt = 1; $multiCnt <= BP_AUS_MAX_MULTI_FIELDS; $multiCnt++){
				$optValue['multi'.$multiCnt] = filter_var($_POST['bp_aus_lite_settings_multi_'.$multiCnt],FILTER_SANITIZE_NUMBER_INT);
			}
			for($orCnt = 1; $orCnt <= BP_AUS_MAX_OR_GROUPS; $orCnt++){
				$optValue['or'.$orCnt] = array();

				if (!empty($_POST['bp_aus_lite_settings_or_'.$orCnt]) && is_array($_POST['bp_aus_lite_settings_or_'.$orCnt])){
					foreach ($_POST['bp_aus_lite_settings_or_'.$orCnt] as $value){
						$optValue['or'.$orCnt][] = filter_var($value,FILTER_SANITIZE_NUMBER_INT);
					}
				} else{
					$optValue['or'.$orCnt] = array();
				}
			}

			if(update_option('bp_aus_lite_settings',$optValue)) $txt .= '<div class="updated fade">'.translate('Buddy Press Advanced User Search Settings updated successfully.','buddypress').'</div>';
			else $txt .= '<div class="error">'.translate('Buddy Press Advanced User Search Settings not updated or nothing was changed.','buddypress').'</div>';
			//echo "<pre>"; print_r(get_option('bp_aus_lite_settings')); die;
		}
		echo $txt;
		unset($_POST);
		bp_aus_lite_screentabs_settings_form();
	}
	else bp_aus_lite_html_errormsg('You have to be logged as a adminitrator to make changes in BuddyPress Advanced User Search');
}
?>
