<?php
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) die;

function bp_aus_lite_sql_bp_fields($listOfFields = 'all'){
	global $bp;
	global $wpdb;
	$usedFields = array();
	//$sql = "SELECT `id`,`name` FROM `{$bp->profile->table_name_fields}` WHERE `parent_id`=0";
	$sql = "SELECT fields.`id`,fields.`name` FROM `{$bp->profile->table_name_fields}` fields INNER JOIN `{$bp->profile->table_name_groups}` groups ON fields.`group_id` = groups.`id` WHERE fields.`parent_id` = 0";

	if (is_array($listOfFields) && sizeof($listOfFields)){
		//$sql .= " AND `id` IN(" . implode(",",$listOfFields). ")";
		$sql .= " AND fields.`id` IN(" . implode(",",$listOfFields). ")";
	}

	//$sql .= " ORDER BY `field_order` ASC";
	$sql .= " ORDER BY groups.`group_order`, fields.`field_order` ASC";

	$found = $wpdb->get_results($sql);
	foreach ($found as $data){
		$usedFields[$data->id] = $data->name;
	}
	return $usedFields;
}

function bp_aus_lite_sql_limit($maxResults , $actualPage = ''){
	$limit = "";
	if ($maxResults > 0){
		if (isset($_GET['paged'])){
			if (is_numeric($_GET['paged'])){
				$firtNo = ($_GET['paged'] * $maxResults) - $maxResults;
				$limit .= " LIMIT {$firtNo},{$maxResults}";
			}
			else $limit .= " LIMIT 0,{$maxResults}";
		}
		elseif ($actualPage != ''){
			if (is_numeric($actualPage)){
				$firtNo = ($actualPage * $maxResults) - $maxResults;
				$limit .= " LIMIT {$firtNo},{$maxResults}";
			}
			else $limit .= " LIMIT 0,{$maxResults}";
		}
		else $limit .= " LIMIT 0,{$maxResults}";
	}
	return $limit;
}

function bp_aus_lite_sql_prepare_settings($optionMode = 'bp_aus_lite_settings'){
	$options = array();
	$SearchOptions = get_option($optionMode);
	if (is_numeric($SearchOptions['max_results_on_page'])) $options['max_results_on_page'] = $SearchOptions['max_results_on_page'];
	else $options['max_results_on_page'] = 5;

	$options['search_options'] = $SearchOptions['search_options'];
	$options['search_type'] = $SearchOptions['search_type'];
	$options['search_type_checkbox'] = $SearchOptions['search_type_checkbox'];
	$options['query_val_left'] = '';
	$options['query_val_right'] = '';

	switch($SearchOptions['search_options']){
		case 'LIKE %searched value%':
			$options['query_type'] = "LIKE";
			$options['query_val_left'] = '%';
			$options['query_val_right'] = '%';
		break;
		case 'LIKE %searched value':
			$options['query_type'] = "LIKE";
			$options['query_val_left'] = '%';
			$options['query_val_right'] = '';
		break;
		case 'LIKE searched value%':
			$options['query_type'] = "LIKE";
			$options['query_val_left'] = '';
			$options['query_val_right'] = '%';
		break;
		case '= searched value':
			$options['query_type'] = "=";
		break;
		case '<> searched value':
			$options['query_type'] = "<>";
		break;
		case '> searched value':
			$options['query_type'] = ">";
		break;
		case '< searched value':
			$options['query_type'] = "<";
		break;
		case '>= searched value':
			$options['query_type'] = ">=";
		break;
		case '<= searched value':
			$options['query_type'] = "<=";
		break;
	}
	return $options;
}

function bp_aus_lite_sql_fast_search( $maxResults = 0 ){
	global $bp;
	global $wpdb;

	$searchedValue = '';
	$ResultBack = array();

	if (isset($_POST['bp_aus_lite_fast_search'])){
		unset($_SESSION['bp_advanced_user_search']);
		$searchedValue = $_POST['bp_aus_lite_fast_search'];
		$_SESSION['bp_advanced_user_search']['mode'] = 'fast';
		$_SESSION['bp_advanced_user_search']['phrase'] = stripslashes($_POST['bp_aus_lite_fast_search']);
	}
	elseif (isset($_SESSION['bp_advanced_user_search'])){
		$searchedValue = $_SESSION['bp_advanced_user_search']['phrase'];
	}


	if ($searchedValue != ''){
		$SearchOptions = bp_aus_lite_sql_prepare_settings();
		if ($maxResults != 0) $maxResults = $SearchOptions['max_results_on_page'];
		$ResultBack['max'] = $maxResults;
		$fastQ = "SELECT COUNT(DISTINCT(`user_id`)) AS `usr_found` FROM `{$bp->profile->table_name_data}` WHERE `value` {$SearchOptions['query_type']} %s";
		$prepared = $wpdb->prepare($fastQ, $SearchOptions['query_val_left'].$searchedValue.$SearchOptions['query_val_right']);
		//print $prepared.'<br />';
		$found = $wpdb->get_results($prepared);
		$ResultBack['found'] = $found[0]->usr_found;
		if ($ResultBack['found'] > 0){
			$fullQuery = "SELECT DISTINCT(`user_id`) AS `user_id` FROM `{$bp->profile->table_name_data}` WHERE `value` {$SearchOptions['query_type']} %s";
			$fullQuery .= bp_aus_lite_sql_limit($maxResults);
			$fullPrepared = $wpdb->prepare($fullQuery,$SearchOptions['query_val_left'].$searchedValue.$SearchOptions['query_val_right']);
			$ResultBack['result'] = $wpdb->get_results($fullPrepared);
		}
		else $ResultBack['error'] = 'No results found for specified search criteria.';
	}
	else $ResultBack['error'] = 'Please input search phrase.';
	return $ResultBack;
}

function bp_aus_lite_sql_detailed_search($maxResults = 0){
	global $bp;
	global $wpdb;
	global $field;

	$usedFields = bp_aus_lite_sql_bp_fields();
	$options = get_option('bp_aus_lite_settings');
	$q1SubWhere = "";
	$q1SubWhere2 = "";
	$q2SubWhere = "";
	$tablePrefix = "";
	$counter = 0;
	$q2Fields['and'] = array();
	$q2Fields['or'] = array();
	$checkboxFields = array();
	$searchedFields = array();
	$ResultBack = array();
	$SearchOptions = bp_aus_lite_sql_prepare_settings();
	if ($maxResults != 0) $maxResults = $SearchOptions['max_results_on_page'];
	$ResultBack['max'] = $maxResults;

	if (isset($_POST['bp_aus_lite_search_group']) && is_numeric($_POST['bp_aus_lite_search_group'])){
		$tablePrefix = "data.";
		$fastQ = "SELECT COUNT(DISTINCT({$tablePrefix}`user_id`)) AS usr_found FROM `{$bp->profile->table_name_data}` data LEFT JOIN `{$wpdb->prefix}bp_groups_members` members ON {$tablePrefix}`user_id` = members.`user_id` WHERE ";
		$fullQuery = "SELECT DISTINCT({$tablePrefix}`user_id`) AS user_id FROM {$bp->profile->table_name_data} data LEFT JOIN `{$wpdb->prefix}bp_groups_members` members ON {$tablePrefix}`user_id` = members.`user_id` WHERE ";
	} else{
		$fastQ = "SELECT COUNT(DISTINCT({$tablePrefix}`user_id`)) AS usr_found FROM `{$bp->profile->table_name_data}` WHERE ";
		$fullQuery = "SELECT DISTINCT({$tablePrefix}`user_id`) AS user_id FROM {$bp->profile->table_name_data} WHERE ";
	}

	if (isset($_POST['search-type']) && $_POST['search-type'] == 'advanced'){
		unset($_SESSION['bp_advanced_user_search']);
		$_SESSION['bp_advanced_user_search']['mode'] = 'advanced';
	}

	$alreadySet = get_option('bp_aus_lite_settings');
	$RangeFields = array();
	for ($rangeCnt = 1; $rangeCnt <= BP_AUS_MAX_RANGE_FIELDS; $rangeCnt++){
		if (!empty($alreadySet['range'.$rangeCnt])) array_push($RangeFields, $alreadySet['range'.$rangeCnt]);
	}

	$MultiFields = array();
	for ($multiCnt = 1; $multiCnt <= BP_AUS_MAX_MULTI_FIELDS; $multiCnt++){
		if (!empty($alreadySet['multi'.$multiCnt])) array_push($MultiFields, $alreadySet['multi'.$multiCnt]);
	}

	$OrFields = array();
	for ($orCnt = 1; $orCnt <= BP_AUS_MAX_OR_GROUPS; $orCnt++){
		if (!empty($alreadySet['or'.$orCnt])) array_push($OrFields, $alreadySet['or'.$orCnt]);
	}

	$i = 0;

	foreach ($usedFields as $used_field_id => $used_field_name){
		$searchedValue = '';
		$searchedField = '';

		$field = new BP_XProfile_Field($used_field_id);

		if ($field->type == 'checkbox'){
			if (!empty($_POST['field_'.$used_field_id])){
				foreach ($_POST['field_'.$used_field_id] as $key => $value){
					$searchedValue[] = xprofile_sanitize_data_value_before_save($value, $used_field_id);
				}
			} elseif (!empty($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id])){
				foreach ($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id] as $key => $value){
					$searchedValue[] = xprofile_sanitize_data_value_before_save($value, $used_field_id);
				}
			}

			if (!empty($searchedValue) && is_numeric($used_field_id) && $used_field_id){
				$checkboxFields[] = $used_field_id;

				foreach ($OrFields as $key => $OrField){
					if (in_array($used_field_id, $OrField)){
						$searchedField = $used_field_id;
						$q2Fields['or'][$key + 1][$searchedField] = $searchedValue;

						break;
					}
				}

				if (!isset($q2Fields['or'][$key + 1][$searchedField])){
					$searchedField = $used_field_id;
					$q2Fields['and'][$searchedField] = $searchedValue;
				}
			}
		}
		elseif ($field->type == 'datebox'){
			if (!empty($_POST['date_day_field_'.$used_field_id]) && !empty($_POST['date_month_field_'.$used_field_id]) && !empty($_POST['date_year_field_'.$used_field_id])){
				if (checkdate($_POST['date_month_field_'.$used_field_id], $_POST['date_day_field_'.$used_field_id], $_POST['date_year_field_'.$used_field_id])){
					$tmpSearch = $_POST['date_year_field_'.$used_field_id] .'-'. $_POST['date_month_field_'.$used_field_id] .'-'. $_POST['date_day_field_'.$used_field_id] . ' 00:00:00';
					$searchedValue = xprofile_sanitize_data_value_before_save($tmpSearch);
				}
			} elseif (isset($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id]) && $_SESSION['bp_advanced_user_search']['detailed'][$used_field_id] !== ''){
				$tmpSearch = date('d-m-Y',strtotime($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id]));
				if (checkdate($tmpSearch[1],$tmpSearch[0],$tmpSearch[2])){
					$searchedValue = xprofile_sanitize_data_value_before_save($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id]);
				}
			}

			if ($searchedValue !== "" && is_numeric($used_field_id) && $used_field_id){
				foreach ($OrFields as $key => $OrField){
					if (in_array($used_field_id, $OrField)){
						$searchedField = $used_field_id;
						$q2Fields['or'][$key + 1][$searchedField] = $searchedValue;

						break;
					}
				}

				if (!isset($q2Fields['or'][$key + 1][$searchedField])){
					$searchedField = $used_field_id;
					$q2Fields['and'][$searchedField] = $searchedValue;
				}
			}
		}
		elseif (in_array($used_field_id, $RangeFields)){
			//range fields
			$RangeType = '';
			$RangeValue1 = '';
			$RangeValue2 = '';
			$q1SubWhere2 = '';

			if (isset($_POST['field_'. $used_field_id .'_range_opt'])){
				$RangeType = $_POST['field_'. $used_field_id .'_range_opt'];
				$_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range_opt'] = $_POST['field_'. $used_field_id .'_range_opt'];
			}
			elseif (isset($_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range_opt'])) $RangeType = $_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range_opt'];

			//single and multiple here
			if (isset($_POST['field_'. $used_field_id .'_range1'])){
				if ($_POST['field_'. $used_field_id .'_range1'] != ''){
					$RangeValue1 = $_POST['field_'. $used_field_id .'_range1'];
					$_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range1'] = $_POST['field_'. $used_field_id .'_range1'];
				}
			}
			elseif (isset($_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range1'])){
				if ($_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range1'] !== '') $RangeValue1 = $_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range1'];
			}

			//just multiple
			if ($RangeType !== 'single'){
				if (isset($_POST['field_'. $used_field_id .'_range2'])){
					if ($_POST['field_'. $used_field_id .'_range2'] != ''){
						$RangeValue2 = $_POST['field_'. $used_field_id .'_range2'];
						$_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range2'] = $_POST['field_'. $used_field_id .'_range2'];
					}
				}
				elseif (isset($_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range2'])){
					if ($_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range2'] !== '') $RangeValue2 = $_SESSION['bp_advanced_user_search']['detailed']['field_'. $used_field_id .'_range2'];
				}
			}

			$RangeValue1 = xprofile_sanitize_data_value_before_save($RangeValue1);
			$RangeValue2 = xprofile_sanitize_data_value_before_save($RangeValue2);

			if (!empty($RangeValue1) || !empty($RangeValue2)){
				if (empty($RangeValue2)){ //single
					$q1SubWhere2 = "({$tablePrefix}`field_id`='{$used_field_id}' AND {$tablePrefix}`value` = '{$RangeValue1}')";

					foreach ($OrFields as $key => $OrField){
						if (in_array($used_field_id, $OrField)){
							$searchedField = $used_field_id;
							$q2Fields['or'][$key + 1][$searchedField] = $RangeValue1;

							break;
						}
					}

					if (!isset($q2Fields['or'][$key + 1][$searchedField])){
						$searchedField = $used_field_id;
						$q2Fields['and'][$searchedField] = $RangeValue1;
					}
				}
				else{
					$q1SubWhere2 = "({$tablePrefix}`field_id`='{$used_field_id}' AND {$tablePrefix}`value` >= '{$RangeValue1}' AND {$tablePrefix}`value` <= '{$RangeValue2}')";

					foreach ($OrFields as $key => $OrField){
						if (in_array($used_field_id, $OrField)){
							$searchedField = $used_field_id;
							$q2Fields['or'][$key + 1][$searchedField] = $RangeValue1 . "," . $RangeValue2;

							break;
						}
					}

					if (!isset($q2Fields['or'][$key + 1][$searchedField])){
						$searchedField = $used_field_id;
						$q2Fields['and'][$searchedField] = $RangeValue1 . "," . $RangeValue2;
					}
				}
			}
		}
		elseif (in_array($used_field_id, $MultiFields)){
			$bp_aus_lite_field['field_'.$used_field_id] = array();

			if (isset($_POST['field_'.$used_field_id]) && is_array($_POST['field_'.$used_field_id]) && !empty($_POST['field_'.$used_field_id])){
				$bp_aus_lite_field['field_'.$used_field_id] = $_POST['field_'.$used_field_id];
			} elseif (isset($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id]) && is_array($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id]) && !empty($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id])){
				$bp_aus_lite_field['field_'.$used_field_id] = $_SESSION['bp_advanced_user_search']['detailed'][$used_field_id];
			}

			foreach ($bp_aus_lite_field['field_'.$used_field_id] as &$value){
				if (($value = trim($value)) !== ""){
					$searchedValue[] = xprofile_sanitize_data_value_before_save($value, $used_field_id);
				}
			}

			if (!empty($searchedValue) && is_numeric($used_field_id) && $used_field_id){
				foreach ($OrFields as $key => $OrField){
					if (in_array($used_field_id, $OrField)){
						$searchedField = $used_field_id;
						$q2Fields['or'][$key + 1][$searchedField] = $searchedValue;

						break;
					}
				}

				if (!isset($q2Fields['or'][$key + 1][$searchedField])){
					$searchedField = $used_field_id;
					$q2Fields['or'][0][$searchedField] = $searchedValue;
				}
			}
		}
		else{
			if (isset($_POST['field_'.$used_field_id]) && ($_POST['field_'.$used_field_id] = trim($_POST['field_'.$used_field_id])) !== ''){
				$searchedValue = xprofile_sanitize_data_value_before_save($_POST['field_'.$used_field_id], $used_field_id);
			} elseif (isset($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id]) && ($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id] = trim($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id])) !== ''){
				$searchedValue = xprofile_sanitize_data_value_before_save($_SESSION['bp_advanced_user_search']['detailed'][$used_field_id], $used_field_id);
			}

			if ($searchedValue !== "" && is_numeric($used_field_id) && $used_field_id){
				foreach ($OrFields as $key => $OrField){
					if (in_array($used_field_id, $OrField)){
						$searchedField = $used_field_id;
						$q2Fields['or'][$key + 1][$searchedField] = $searchedValue;

						break;
					}
				}

				if (!isset($q2Fields['or'][$key + 1][$searchedField])){
					$searchedField = $used_field_id;
					$q2Fields['and'][$searchedField] = $searchedValue;
				}
			}
		}

		if ($searchedValue !== '' && $searchedField !== ''){
			$searchedFields[] = $searchedField;

			if ($i++){
				$q1SubWhere .= " OR ";
			}

			if (is_array($searchedValue)){
				$_SESSION['bp_advanced_user_search']['detailed'][$searchedField] = array();

				foreach ($searchedValue as $key => $value){
					if ($key){
						$q1SubWhere .= " OR ";
					}

					$_SESSION['bp_advanced_user_search']['detailed'][$searchedField][] = stripslashes($value);

					$q1SubWhere .= "({$tablePrefix}`field_id`='{$searchedField}' AND {$tablePrefix}`value` {$SearchOptions['query_type']} '{$SearchOptions['query_val_left']}{$value}{$SearchOptions['query_val_right']}')";
					$q2SubWhere .= "({$tablePrefix}`field_{$searchedField}` {$SearchOptions['query_type']} '{$SearchOptions['query_val_left']}{$value}{$SearchOptions['query_val_right']}')";
				}
			} else{
				$_SESSION['bp_advanced_user_search']['detailed'][$searchedField] = stripslashes($searchedValue);

				$q1SubWhere .= "({$tablePrefix}`field_id`='{$searchedField}' AND {$tablePrefix}`value` {$SearchOptions['query_type']} '{$SearchOptions['query_val_left']}{$searchedValue}{$SearchOptions['query_val_right']}')";
			}
		}
		elseif ($q1SubWhere2 !== ''){
			$searchedFields[] = $searchedField;

			if ($i++){
				$q1SubWhere .= " OR ";
			}

			$q1SubWhere .= $q1SubWhere2;
			$q1SubWhere2 = "";
		}
	}
	// end foreach

	if (isset($_POST['bp_aus_lite_search_group']) && is_numeric($_POST['bp_aus_lite_search_group'])){
		$_SESSION['bp_advanced_user_search']['detailed']['bp_aus_lite_search_group'] = stripslashes($_POST['bp_aus_lite_search_group']);
		$q1SubWhere .= " AND members.`group_id` = '{$_POST['bp_aus_lite_search_group']}'";
	}

	//print_r($q2Fields['and']); die;
	$counter = sizeof($q2Fields['or']) ? sizeof($q2Fields['and']) + 1 : sizeof($q2Fields['and']);

	if ($counter){
		//new thing for better results
		sort($searchedFields);

		//$q1SubWhere .= " GROUP BY {$tablePrefix}`user_id` HAVING COUNT(1) >= {$counter}";
		$q1SubWhere .= " GROUP BY {$tablePrefix}`user_id`";
		$fastQ .= $q1SubWhere;

		//print_r($fastQ); //die;
		$found = $wpdb->get_results($fastQ);

		if (sizeof($found)){
			$fullQuery .= $q1SubWhere;
			//print_r($fullQuery); die;

			// Stop here and return the results if there is no AND search criteria
			// There is no need to go any further to refine the results
			if ($counter === 1){
				$fullQuery .= bp_aus_lite_sql_limit($maxResults);

				$ResultBack['found'] = sizeof($found);
				$ResultBack['result'] = $wpdb->get_results($fullQuery);

				return $ResultBack;
			}

			$ResultBack['result'] = $wpdb->get_results($fullQuery);

			//echo $fullQuery; die;

			foreach ($ResultBack['result'] as $row){
				$ids[] = $row->user_id;
			}

			// Build the final refined search sub-query
			$subQuery = "SELECT {$tablePrefix}`user_id`, ";

			foreach ($searchedFields as $key => $value){
				$subQuery .= "GROUP_CONCAT(IF({$tablePrefix}`field_id` = " . $value . ", value, NULL)) AS field_" . $value;

				if ($key < sizeof($searchedFields) - 1){
					$subQuery .= ", ";
				} else{
					$subQuery .= " ";
				}
			}

			$subQuery .= "FROM `{$bp->profile->table_name_data}` WHERE {$tablePrefix}`user_id` IN (" . implode(',', $ids) . ") AND {$tablePrefix}`field_id` IN (" . implode(',', $searchedFields) . ") GROUP BY {$tablePrefix}`user_id`";
			//print_r($subQuery); die;

			// Build the final refined search query
			$q2SubWhere = "";
			$i = 0;
			//echo "<pre>"; print_r($q2Fields); die;

			foreach ($q2Fields['and'] as $fieldID => $value){
				if ($i && $i < sizeof($q2Fields['and'])){
					$q2SubWhere .= " AND ";
				}

				if (in_array($fieldID, $RangeFields)){
					$value = explode(',', $value);

					if (sizeof($value) === 1){
						$q2SubWhere .= "{$tablePrefix}`field_{$fieldID}` = '{$value[0]}'";
					} elseif (sizeof($value) === 2){
						$q2SubWhere .= "({$tablePrefix}`field_{$fieldID}` >= '{$value[0]}' AND {$tablePrefix}`field_{$fieldID}` <= '{$value[1]}')";
					}
				} else{
					if (in_array($fieldID, $checkboxFields)){
						$q2SubWhereArr = array();

						foreach ($value as $value2){
							$q2SubWhereArr[] = "{$tablePrefix}`field_{$fieldID}` {$SearchOptions['query_type']} '{$SearchOptions['query_val_left']}{$value2}{$SearchOptions['query_val_right']}'";
						}

						if (strtolower($SearchOptions['search_type_checkbox']) == "or"){
							$q2SubWhere .= "(" . implode(' OR ', $q2SubWhereArr) . ")";
						} else{
							$q2SubWhere .= "(" . implode(' AND ', $q2SubWhereArr) . ")";
						}
					} else{
						$q2SubWhere .= "{$tablePrefix}`field_{$fieldID}` {$SearchOptions['query_type']} '{$SearchOptions['query_val_left']}{$value}{$SearchOptions['query_val_right']}'";
					}
				}

				$i++;
			}

			$i = 0;

			foreach ($q2Fields['or'] as $value){
				$i2 = 0;

				if (!$i && sizeof($q2Fields['and'])){
					$q2SubWhere .= " AND ";
				} elseif ($i && $i < sizeof($q2Fields['or'])){
					$q2SubWhere .= " AND ";
				}

				foreach ($value as $fieldID => $value2){
					if (!$i2){
						$q2SubWhere .= "(";
					} elseif ($i2 && $i2 < sizeof($value)){
						$q2SubWhere .= " OR ";
					}

					if (is_array($value2) && !in_array($fieldID, $checkboxFields)){
						foreach ($value2 as $key2 => $valueMulti){
							if (!$key2 && sizeof($value) > 1){
								$q2SubWhere .= "(";
							} elseif ($key2 && $key2 < sizeof($value2)){
								$q2SubWhere .= " OR ";
							}

							$q2SubWhere .= "{$tablePrefix}`field_{$fieldID}` {$SearchOptions['query_type']} '{$SearchOptions['query_val_left']}{$valueMulti}{$SearchOptions['query_val_right']}'";

							if ($key2 == sizeof($value2) - 1 && sizeof($value) > 1){
								$q2SubWhere .= ")";
							}
						}
					} elseif (in_array($fieldID, $RangeFields)){
						$value2 = explode(',', $value2);

						if (sizeof($value2) === 1){
							$q2SubWhere .= "{$tablePrefix}`field_{$fieldID}` = '{$value2[0]}'";
						} elseif (sizeof($value2) === 2){
							$q2SubWhere .= "({$tablePrefix}`field_{$fieldID}` >= '{$value2[0]}' AND {$tablePrefix}`field_{$fieldID}` <= '{$value2[1]}')";
						}
					} elseif (in_array($fieldID, $checkboxFields)){
						$q2SubWhereArr = array();

						foreach ($value2 as $value3){
							$q2SubWhereArr[] = "{$tablePrefix}`field_{$fieldID}` {$SearchOptions['query_type']} '{$SearchOptions['query_val_left']}{$value3}{$SearchOptions['query_val_right']}'";
						}

						if (strtolower($SearchOptions['search_type_checkbox']) == "or"){
							$q2SubWhere .= "(" . implode(' OR ', $q2SubWhereArr) . ")";
						} else{
							$q2SubWhere .= "(" . implode(' AND ', $q2SubWhereArr) . ")";
						}
					} else{
						$q2SubWhere .= "{$tablePrefix}`field_{$fieldID}` {$SearchOptions['query_type']} '{$SearchOptions['query_val_left']}{$value2}{$SearchOptions['query_val_right']}'";
					}

					if ($i2 == sizeof($value) - 1){
						$q2SubWhere .= ")";
					}

					$i2++;
				}

				$i++;
			}

			//echo $q2SubWhere . "<br><br>"; die;

			$fastQ = "SELECT COUNT(DISTINCT(`user_id`)) AS `usr_found` FROM (" . $subQuery . ") AS fieldVals WHERE " . $q2SubWhere;
			$fullQuery = "SELECT DISTINCT(`user_id`) AS `user_id` FROM (" . $subQuery . ") AS fieldVals WHERE " . $q2SubWhere;
			$fullQuery .= bp_aus_lite_sql_limit($maxResults);

			//echo $fullQuery . "<br><br>"; die;

			$found = $wpdb->get_results($fastQ);

			if (isset($found[0]->usr_found) && (int)$found[0]->usr_found){
				$ResultBack['found'] = $found[0]->usr_found;
				$ResultBack['result'] = $wpdb->get_results($fullQuery);
			} else{
				$ResultBack['error'] = 'No results found for specified search criteria.';

				unset($ResultBack['found']);
			}
		}
		else $ResultBack['error'] = 'No results found for specified search criteria.';
	}
	else $ResultBack['error'] = 'There are no search criteria specified.';

	return $ResultBack;
}
?>
